"use strict";

var MozChunkedBackend = require('./moz-chunked-backend.js');
var MSStreamBackend = require('./msstream-backend.js');
var BinaryStringBackend = require('./binary-string-backend.js');

function autoselect() {
  if (MozChunkedBackend.supported()) {
    return MozChunkedBackend;
  } else if (BinaryStringBackend.supported()) {
    return BinaryStringBackend;
  } else if (MSStreamBackend.supported()) {
    return MSStreamBackend;
  } else {
    return null;
  }
}

var backendClass = null;

function instantiate(options) {
  if (!backendClass) {
    backendClass = autoselect();
  }
  if (!backendClass) {
    throw new Error('No supported backend class');
  }
  return new backendClass(options);
}

module.exports = instantiate;
